var $ = jQuery;
$(function() {
    const SCIENTIFIC = 'scientific_coursework';
    const DISCIPLINARY = 'disciplinary_coursework';

    var INPUT_BORDER_COLOR = "#d7d7d7";
    var jSubjectSelect = $("select.SelectSubject");
    var jSubjectInput = $("input.InputSubject ");
    var jGradeSelect = $("select.SelectGrade");
    var jType = $("input[name=subtype]");

    // Изменения базовых параметров дисциплины
    $(".AddDiscipline").click(function() {
        var self = $(this);
        self.attr("disabled", true);

        var discipline = {
            "subjectID": parseInt(jSubjectSelect.val()),
            "gradeID": parseInt(jGradeSelect.val()),
            "facultyID": $("select.SelectFaculty").val(),
            "subtype": jType.filter(":radio:checked").val() == 'scientific' ? SCIENTIFIC : DISCIPLINARY,
            'semesterID': getRecordBook()
        };

        var errCount = 0;

        if (discipline.subtype === undefined) {
            jType.first().parent().parent().css("background-color", "#f2b4b4");
            ++errCount;
        }

        var incorrectID = (!isNum(discipline.subjectID) || discipline.subjectID <= 0);
        if (incorrectID && discipline.subtype != SCIENTIFIC) {
            jSubjectInput.css("border-color", "red");
            ++errCount;
        }

        if (!isNum(discipline.gradeID) || discipline.gradeID <= 0) {
            jGradeSelect.css("border-color", "red");
            ++errCount;
        }

        if (errCount === 0) {
            $.post(
                g_URLdir + "handler/courseWork/create", discipline, function(res) {
                    var response = $.parseJSON(res);

                    if (response.error) {
                        self.removeAttr("disabled");
                        EventInspector.error("Ошибка при добавлении курсовой");
                    } else {
                        setTimeout("location.replace('" + g_URLdir + "discipline/" + response["response"].ID + "')", 200);
                    }
                }
            );
        } // errCount === 0 
        else {
            self.removeAttr("disabled");
            EventInspector.error("Заполнены не все поля");
        }
    });

    jSubjectSelect.change(function() {
        if ($(this).val() > 0)
            jSubjectSelect.css("border-color", INPUT_BORDER_COLOR);
    });

    jGradeSelect.change(function() {
        if ($(this).val() > 0)
            jGradeSelect.css("border-color", INPUT_BORDER_COLOR);
    });

    jType.change(function() {
        var value = jType.filter(":radio:checked").val();
        if (value in ['disciplinary', 'scientific'])
            $(this).parent().parent().css("background-color", "#fff");

        if (value === 'scientific') {
            jSubjectSelect.attr("disabled", "disabled");
            $("#subjects").fadeOut(500);
        } else {
            jSubjectSelect.removeAttr("disabled");
            $("#subjects").fadeIn(500);
        }
    });
});
